using System;

namespace DinoDelight
{
   public class Dinosaur : IComparable, ICarnivore
   {
      private string m_Name;
      public int Length = 0;    
      public string Name {
         get {
            return m_Name;
         }
         set {
            m_Name = value;
         }
      }

    public int CompareTo (object obj) {
         Dinosaur dino = (Dinosaur) obj;
         return this.Name.CompareTo (dino.Name);
      }
  
      public bool CanIEatU (object obj){
         Dinosaur dino = (Dinosaur) obj;
         if (this.Length > dino.Length)
			return true;
		else
			return false;
      }

   }

   class Lessemsaurus : Dinosaur {
      public Lessemsaurus (string theName, int length){
         this.Name = theName;
         this.Length = length;
      }
   }

   class Apatosaurus : Dinosaur {
      public Apatosaurus (string theName, int length){
         this.Name = theName;
         this.Length = length;
      }
   }
   
   class Diplodocus : Dinosaur {
      public Diplodocus (string theName, int length){
         this.Name = theName;
      }
    }

   class Allosaurus : Dinosaur {
      public Allosaurus (string theName, int length){
         this.Name = theName;
         this.Length = length;
      }
    }
   class TRex : Dinosaur {
      public TRex (string theName, int length){
         this.Name = theName;
         this.Length = length;
      }
   }

   interface ICarnivore {
      bool CanIEatU (object obj);
   }
}
